#
#  Linux Desktop Testing Project http://www.gnomebangalore.org/ldtp
#
#  Author:
#     Prem <jpremkumar@novell.com>
#     Venkateswaran S <wenkat.s@gmail.com>
#
#  Copyright 2004 Novell, Inc.
#
#  This test script is free software; you can redistribute it and/or
#  modify it under the terms of the GNU Library General Public
#  License as published by the Free Software Foundation; either
#  version 2 of the License, or (at your option) any later version.
#
#  This library is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  Library General Public License for more details.
#
#  You should have received a copy of the GNU Library General Public
#  License along with this library; if not, write to the
#  Free Software Foundation, Inc., 59 Temple Place - Suite 330,
#  Boston, MA 02111-1307, USA.
#

#To create an Appointment
from evoutils.calendar import *
from ldtputils import *

def selectCalendarPane():
   """Selects the Contacts Pane in Evolution"""
   log ('Open Evolution Contacts Pane','teststart')
   setcontext ('Evolution - Mail','Evolution - Mail')
   #code to find the present window and revert back to the Contacts Pane
   if guiexist('frmEvolution-Mail')!=1:
        log ('Present Window now Mail pane','info')
        setcontext ('Evolution - Mail','Evolution - Contacts')
        if guiexist('frmEvolution-Mail')!=1:
             log ('Present Window now Contacts pane','info')
             setcontext ('Evolution - Mail','Evolution - Calendars')
             if guiexist('frmEvolution-Mail')!=1:
                  log ('Present Window now Calendars pane','info')
                  setcontext ('Evolution - Mail','Evolution - Memos')
                  if guiexist('frmEvolution-Mail')!=1:
                       log ('Present Window now Memos pane','info')
                       setcontext ('Evolution - Mail','Evolution - Tasks')
                       log ('Present Window has to be Taskspane','info')
   time.sleep (1)
   try:
       click ('frmEvolution-Mail','tbtnCalendars')
       time.sleep(3)
       waittillguiexist ('frmEvolution-Calendars')

   except:
       log ('error selecting Contacts pane','error')
       log ('Open Evolution Contacts Pane','testend')
       raise LdtpExecutionError(0)

   log ('Open Evolution Contacts Pane','testend')

def read_data():
	#Initialising XML parser with data file
	data_object = LdtpDataFileParser (datafilename)
	
	#Extracting imput data from xml file
	summary = data_object.gettagvalue ('summary')[0]
	location = data_object.gettagvalue ('location')[0]
	description = data_object.gettagvalue ('description')[0]
	from_date = data_object.gettagvalue ('from_date')[0]
	to_date = data_object.gettagvalue ('to_date')[0]
	from_time = data_object.gettagvalue ('from_time')[0]
	to_time = data_object.gettagvalue ('to_time')[0]
	calendar = data_object.gettagvalue ('calendar')[0]
	return summary, location, description, from_date, to_date, from_time, to_time, calendar

def create_appoinment():
	log ('Appointment Creation', 'teststart')
	try:
		windowname = 'frmAppointment-Nosummary'
	    	flag = 0
		more_items_todo = 'no'
		summary, location, description, from_date, to_date, from_time, to_time, calendar = read_data()
		
	    	selectmenuitem ('frmEvolution-Calendars', 'mnuFile;mnuFile;mnuAppointment')
	    	time.sleep (3)
	    	if guiexist (windowname) == 0:
	        	log ('Failed to open new appointment window', 'cause')
	        	raise LdtpExecutionError (0)
	    	else:
			i = insert_appointment (windowname, summary, location, description, from_date, from_time, to_date, to_time, calendar,more_items_todo)
		log('The user details have been entered in the appointment','info')
		if i == 1:
            		flag = 1
        	time.sleep (2)
		
	except:
		log('unable to Create a new appoinment','error')
		log ('Appointment Creation', 'testend')
		raise LdtpExecutionError (0)

	log('Appointment created','info')
	log ('Appointment Creation', 'testend')

selectCalendarPane()
create_appoinment()
